import 'package:flutter/cupertino.dart';
import 'package:foundation_fluttify/foundation_fluttify.dart';
import 'package:netease_live_fluttify/src/android/android.export.g.dart';
import 'package:netease_live_fluttify/src/facade/models.dart';

import 'enums.dart';

class LivePusher with WidgetsBindingObserver {
  /// 创建推流
  static Future<LivePusher> create() async {
    final pusher = LivePusher._();
    debugPrint('此为付费插件, 请联系qq 382146139');

    return pusher;
  }

  LivePusher._() {
    WidgetsBinding.instance.addObserver(this);
  }

  /// 初始化推流
  ///
  /// [pushUrl] 推流地址
  /// [config] 音视频配置
  Future<void> initLiveStream(
    String pushUrl, {
    LiveStreamConfig config = const LiveStreamConfig(),
  }) async {
    debugPrint('此为付费插件, 请联系qq 382146139');
  }

  /// 开始预览
  ///
  /// [preview] SDK提供的预览显示View，用户可以布局到自己的APP中
  /// [frontCamera] 是否默认前置摄像头
  /// [filter] 是否使用SDK内置滤镜
  /// [videoQuality] MEDIUM：标清 480360，HIGH：高清 640480，SUPER：超清 960540，SUPER_HIGH：超高清 1280720
  /// [scale_16x9] 是否按16:9宽高比例
  Future<void> startVideoPreview(
    dynamic preview, {
    bool frontCamera = true,
    bool filter = true,
    VideoQuality videoQuality = VideoQuality.HIGH,
    bool scale_16x9 = false,
  }) async {
    assert(
      preview is com_netease_vcloud_video_render_NeteaseView ||
          preview is UIView,
    );
    debugPrint('此为付费插件, 请联系qq 382146139');
  }

  /// 开始推流
  Future<void> startLiveStream() async {
    debugPrint('此为付费插件, 请联系qq 382146139');
  }

  /// 恢复推流
  Future<void> resumeLiveStream() async {
    debugPrint('此为付费插件, 请联系qq 382146139');
  }

  /// 停止推流
  Future<void> stopLiveStreaming() async {
    debugPrint('此为付费插件, 请联系qq 382146139');
  }

  /// 停止预览
  Future<void> stopVideoPreview() async {
    debugPrint('此为付费插件, 请联系qq 382146139');
  }

  /// 切换摄像头
  Future<void> switchCamera() async {
    debugPrint('此为付费插件, 请联系qq 382146139');
  }

  /// 设置滤镜
  ///
  /// 由于Android和iOS两端支持的滤镜不一致, 所以开放两个参数单独设置. 枚举具体含义请参考枚举
  /// 类的注释.
  Future<void> setFilterType({
    @required FilterTypeAndroid filterTypeAndroid,
    @required FilterTypeIOS filterTypeIOS,
  }) async {
    debugPrint('此为付费插件, 请联系qq 382146139');
  }

  /// 设置滤镜强度
  Future<void> setFilterStrength(double strength) async {
    assert(strength >= 0 && strength <= 1, '滤镜强度范围为0 - 1!');
    debugPrint('此为付费插件, 请联系qq 382146139');
  }

  /// 设置磨皮强度
  ///
  /// [strength] 强度 0 - 1
  Future<void> setSmoothLevel(double strength) async {
    assert(strength >= 0 && strength <= 1, '磨皮强度范围为0 - 1!');
    debugPrint('此为付费插件, 请联系qq 382146139');
  }

  /// 打开/关闭 闪光灯
  Future<void> flash(bool on) async {
    debugPrint('此为付费插件, 请联系qq 382146139');
  }

  /// 摄像头缩放
  Future<void> zoom(int level) async {
    debugPrint('此为付费插件, 请联系qq 382146139');
  }

  /// 调节曝光度
  Future<void> setExposureCompensation(int exposure) async {
    debugPrint('此为付费插件, 请联系qq 382146139');
  }

  /// 销毁资源
  Future<void> dispose() async {
    WidgetsBinding.instance.removeObserver(this);
    debugPrint('此为付费插件, 请联系qq 382146139');
  }

  @override
  void didChangeAppLifecycleState(AppLifecycleState state) async {}
}
